public class Espressioni{

	public static void main(String Args[]){
		
		//variabile inizializzata al momento della dichiarazione
		int primaVariabile=24;
		
		//variabile non inizializzata...
		int secondaVariabile;
		
		//assegnazione di un valore costante
		secondaVariabile=12; 
		
		//assegnazione di un valore ottenuto valutando un'espressione
		secondaVariabile=primaVariabile+primaVariabile;
		
		
		/*
		 *Note: 
		 *
		 *Nel caso dei tipi primitivi, la variabile si comporta esattamente come una
		 *scatola che contiene il valore. L'operazione di assegnazione ha dunque il 
		 *significato: sostituisci ci che c' nella scatola con....
		 *
		 *L'operazione di assegnazione dunque non ha nulla a che vedere con una identit 
		 *matematica (si usa l'uguale solo perch sulle tastiere non c' un simbolo migliore).
		 *Quindi non deve stupire (anzi,  assai frequente) un'assegnazione come quella che segue,
		 *che incrementa di uno il valore della variabile.
		 *
		 */
		 
		 secondaVariabile=secondaVariabile+1;
				
		/*
		 *Ed inoltre un'assegnazione di questo tipo  scorretta:
		 *
		 */
		 
		 //secondaVariabile+1=secondaVariabile;
		
		/*
		 *
		 *Perch sul lato sx dell'assegnazione deve esserci una variabile
		 *mente in questo caso c' un'espressione, cio un valore.
		 *
		 *il compilatore dice: unexpected type
		 */
	
		/*
		 *Come funziona l'assegnazione:
		 *
		 *	1) viene valutato il lato destro dell'assegnazione. Quest'espressione 
		 *	pu contenere variabili, e ciascuna viene valutata in base al suo valore corrente.
		 *  In particolare, l'espressione pu contenere la variabile a cui stiamo assegnando un valore.
		 *
		 *	2) Il valore calcolato viene sostituito a quello corrente della variabile.
		 *
		 *
		 *
		 *Notare che in un'assegnazione il valore assegnato deve sempre rispettare il tipo della variabile che si trova sul 
		 *lato sinistro (la variabile assegnata), fatte salve eventuali conversioni implicite di tipo. 
		 *Dunque:
		 */
	
		 boolean variabileBooleana;
		 
		 //variabileBooleana=primaVariabile+2;   //incompatible types
		 
		 variabileBooleana=primaVariabile>2;   //ok
			
		
		 /*
		  *La stessa cosa vale internamente alle espressioni: certi operatori operano
		  *solo su valori di un certo tipo.
		  */	
		
		
		//variabileBooleana=variabileBooleana+variabileBooleana; //operator + cannot be applied to boolean, boolean
		
		//primaVariabile=!2; //operator ! cannot be applied to int
		
		
		/*
		 *attenzione al fatto che certi operatori sono sovraccarichi (overloaded). 
		 *cio, accettano operandi di tipo diverso, e possono comportarsi diversamente a
		 *seconda del tipo degli operandi.
		 *
		 */		
		
		float variabileFloat;
				
		variabileFloat=7/2;   //operandi interi --> divisione intera (e tipo del risultato intero)
		
		System.out.println(variabileFloat);
		
		variabileFloat=7f/2;	  //un operando float --> divisione in virgola mobile (uno dei due operandi viene "promosso")
		
		System.out.println(variabileFloat);
		
		
		/*
		 *notare che un'inizializzazione al momento della dichiarazione si comporta
		 *come una qualsiasi altra assegnazione. In particolare, a lato destro pu comparire 
		 *un'espressione, eventualmente contenente altre variabili.
		 *
		 */
	
	
		int terzaVariabile=secondaVariabile%2;
 				
 		
 		//Attenzione! l'assegnazione  un'espressione il cui valore  pari al valore del suo lato destro
 		//per cui:
 		
 		terzaVariabile=secondaVariabile=primaVariabile=3;
 		
 		//funziona perfettamente, ed ha il significato
 		
 		terzaVariabile=(secondaVariabile=(primaVariabile=3));
 		
 		
 		/*Altre note:
 		 *solo le espressioni assegnazione e incremento possono formare
 		 *statement a s. Il motivo  chiaro: un'operazione di assegnazione 
 		 * un comando: "modifica il valore della tal variabile", mentre 
 		 *un'espressione  un valore.
 		 *
 		 *Dunque:
 		 */
 		 
 		 //secondaVariabile+1;   un errore (not a statement).
 		 
 		 //mentre
 		  		 
 		 secondaVariabile++; 
 		 
 		 /*
 		  * uno statement perfettamente valido, in quanto di fatto
 		  *corrisponde a
 		  */
 		  
 		 secondaVariabile=secondaVariabile+1;
 		
    }
}


